package bind

import (
	"errors"
	"fmt"
)

type Bindable struct {
	foo   int
	bar   string
	qux   []byte
	baz   float64
	snafu bool
}

func (b Bindable) Foo() int {
	return b.foo
}

func (b Bindable) Bar() (string, error) {
	return b.bar, errors.New(b.bar)
}

func (b Bindable) Qux() ([]byte, error) {
	return b.qux, errors.New("allet jut")
}

func (b Bindable) Baz() float64 {
	return b.Baz()
}

func (b Bindable) Snafu() (bool, error) {
	return false, nil
}

func (b Bindable) WillBeSkippedDueParam(reasons []string) {
	fmt.Printf("Params: %#v", reasons)
}

func (b Bindable) WillBeSkippedDueReturn() (uint64, error) {
	return 500, errors.New("internal server error")
}
