// Package spacedata collects everything to gain data from api.open-notify.org in a cross-platform manner.
package spacedata

import (
	"bufio"
	"bytes"
	"encoding/json"
)

type Providing interface {
	EndpointString() string
	ParseResponse([]byte) ([]byte, error)
}

func encodeJson(v interface{}) ([]byte, error) {
	var byteBuffer bytes.Buffer
	bufferWriter := bufio.NewWriter(&byteBuffer)
	encoder := json.NewEncoder(bufferWriter)
	err := encoder.Encode(v)
	if err != nil {
		return nil, err
	}
	err = bufferWriter.Flush()
	if err != nil {
		return nil, err
	}

	return byteBuffer.Bytes(), err
}
